package me.nvus.nvus_prison_setup.Listeners;

import me.nvus.nvus_prison_setup.PrisonSetup;
import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.player.PlayerItemHeldEvent;
import org.bukkit.inventory.ItemStack;

import java.util.List;

public class PlayerItems implements Listener {

    private final PrisonSetup plugin;

    public PlayerItems(PrisonSetup plugin) {
        this.plugin = plugin;
    }

    @EventHandler(priority = EventPriority.LOWEST)
    public void onPlayerItemHeld(PlayerItemHeldEvent event) {
        Player player = event.getPlayer();
        ItemStack item = player.getInventory().getItem(event.getNewSlot());

        if (item != null && isBannedItem(item.getType())) {
            if (player.hasPermission("nvus.prisoner")) {
                event.setCancelled(true);
                player.sendMessage(ChatColor.RED + "Sorry inmate! You're a prisoner and cannot use this tool!");
            }
        }
    }

    @EventHandler(priority = EventPriority.LOWEST)
    public void onInventoryClick(InventoryClickEvent event) {
        if (event.getClickedInventory() != null && event.getClickedInventory().getType() == org.bukkit.event.inventory.InventoryType.PLAYER) {
            if (event.getSlotType() == org.bukkit.event.inventory.InventoryType.SlotType.QUICKBAR) {
                ItemStack item = event.getCurrentItem();

                if (item != null && isBannedItem(item.getType())) {
                    Player player = (Player) event.getWhoClicked();
                    if (player.hasPermission("nvus.prisoner")) {
                        event.setCancelled(true);
                        player.sendMessage(ChatColor.RED + "Sorry inmate! You're a prisoner and cannot use this tool!");
                    }
                }
            }
        }
    }

    private boolean isBannedItem(Material itemType) {
        FileConfiguration config = plugin.getBannedItemsConfig().getConfig();
        List<String> bannedItems = config.getStringList("BannedItems");
        return bannedItems.contains(itemType.toString());
    }
}
